/*
 * Class to practice with classes
 *
 * @author Jeff Borland
 * @date 12-8-10
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class BallPractice extends JApplet implements MouseListener, MouseMotionListener,ActionListener,KeyListener,Runnable
{
    DroppingBall ball1;
    Graphics bufferGraphics;
    Image offscreen; 

    public void init()
    {
        ball1=new DroppingBall();
        
        offscreen = createImage(500,500);
        bufferGraphics = offscreen.getGraphics(); 
    }

    public void paint (Graphics g)
    {
        super.paint(g);        
    }

    //This is the method that will be called if a key is pressed
    //It is neccessary if you are using getKeyCode()
    public void keyPressed(KeyEvent e)
    {

    }

    //This is the method that will be called if a key is released
    //It is unneccessary to use this method, but you must include it
    public void keyReleased(KeyEvent e)
    {  
    }

    //This is the method that will be called if a key is typed, however you cant use getKeyCode, so
    // you are better to use keyPressed
    public void keyTyped(KeyEvent e)
    {    
    }

    //when someone presses the mouse button
    public void mousePressed(MouseEvent e)
    {     

    }

    //when someone releases the mouse button
    public void mouseReleased(MouseEvent e)
    {     

    }

    // when the mouse enters the applet
    public void mouseEntered(MouseEvent e)
    {     

    }

    //when the mouse leaves the applet
    public void mouseExited(MouseEvent e)
    {     

    }

    //when the mouse button is clicked
    public void mouseClicked(MouseEvent e)
    {
        requestFocus(); //this bring the focus make to the main progra

    }

    //the mouse button is pressed and the mouse makes a significantly large movement
    public void mouseDragged(MouseEvent e)
    {

    }

    //the mouse makes a significantly large movement
    public void mouseMoved(MouseEvent e)
    {
    }

    public void actionPerformed(ActionEvent thisEvent)
    {
        Object source = thisEvent.getSource();

        //now have if statements seeing finding out where the action occured

    }


    public void update()
    {
        bufferGraphics.setColor(Color.white);
        bufferGraphics.fillRect(0,0,500,500);
        
        ball1.move();                        
        ball1.drawBall(bufferGraphics);
        
        Graphics g=getGraphics();      
        g.drawImage(offscreen,0,0,this); 
    }

    /*********************************************************************************************/
    /* BELOW IS FOR ANIMATION.  THE ONLY THING THAT YOU NEED TO CHANGE IS DELAY */

    int frame;
    int delay=50;   // this is the time of the delay in milliseconds.
    Thread animator;

    /**
     * This method is called when the applet becomes visible on
     * the screen. Create a thread and start it.
     */
    public void start()
    {
        animator = new Thread(this);
        animator.start();
    }

    /**
     * This method is called by the thread that was created in
     * the start method. It does the main animation.
     */
    public void run()
    {
        // Remember the starting time
        long tm = System.currentTimeMillis();
        while (Thread.currentThread() == animator)
        {
            // Display the next frame of animation.
            update();
            try
            {
                tm += delay;
                Thread.sleep(Math.max(0, tm - System.currentTimeMillis()));
            }
            catch (InterruptedException e)
            {
                break;
            }
            // Advance the frame
            frame++;
        }
    }

    /**
     * This method is called when the applet is no longer
     * visible. Set the animator variable to null so that the
     * thread will exit before displaying the next frame.
     */
    public void stop()
    {
        animator = null;
    }
}